<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  
  
  <title>Higher Order Function Chaining in JavaScript | Hexo</title>
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <meta name="description" content="Let us assume, we have higher order functions in our code which are performing different operations according to their usage. We have a situation like this, “Calculate the sum of odd numbers in given">
<meta property="og:type" content="article">
<meta property="og:title" content="Higher Order Function Chaining in JavaScript">
<meta property="og:url" content="http://example.com/2021/12/22/chaining/index.html">
<meta property="og:site_name" content="Hexo">
<meta property="og:description" content="Let us assume, we have higher order functions in our code which are performing different operations according to their usage. We have a situation like this, “Calculate the sum of odd numbers in given">
<meta property="og:locale" content="en_US">
<meta property="article:published_time" content="2021-12-22T06:27:50.000Z">
<meta property="article:modified_time" content="2021-12-22T06:28:14.971Z">
<meta property="article:author" content="John Doe">
<meta name="twitter:card" content="summary">
  
    <link rel="alternate" href="/atom.xml" title="Hexo" type="application/atom+xml">
  
  
    <link rel="shortcut icon" href="/favicon.png">
  
  
    
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/typeface-source-code-pro@0.0.71/index.min.css">

  
  
<link rel="stylesheet" href="/css/style.css">

  
    
<link rel="stylesheet" href="/fancybox/jquery.fancybox.min.css">

  
<meta name="generator" content="Hexo 5.4.0"></head>

<body>
  <div id="container">
    <div id="wrap">
      <header id="header">
  <div id="banner"></div>
  <div id="header-outer" class="outer">
    <div id="header-title" class="inner">
      <h1 id="logo-wrap">
        <a href="/" id="logo">Hexo</a>
      </h1>
      
    </div>
    <div id="header-inner" class="inner">
      <nav id="main-nav">
        <a id="main-nav-toggle" class="nav-icon"></a>
        
          <a class="main-nav-link" href="/">Home</a>
        
          <a class="main-nav-link" href="/archives">Archives</a>
        
      </nav>
      <nav id="sub-nav">
        
          <a id="nav-rss-link" class="nav-icon" href="/atom.xml" title="RSS Feed"></a>
        
        <a id="nav-search-btn" class="nav-icon" title="Search"></a>
      </nav>
      <div id="search-form-wrap">
        <form action="//google.com/search" method="get" accept-charset="UTF-8" class="search-form"><input type="search" name="q" class="search-form-input" placeholder="Search"><button type="submit" class="search-form-submit">&#xF002;</button><input type="hidden" name="sitesearch" value="http://example.com"></form>
      </div>
    </div>
  </div>
</header>

      <div class="outer">
        <section id="main"><article id="post-chaining" class="h-entry article article-type-post" itemprop="blogPost" itemscope itemtype="https://schema.org/BlogPosting">
  <div class="article-meta">
    <a href="/2021/12/22/chaining/" class="article-date">
  <time class="dt-published" datetime="2021-12-22T06:27:50.000Z" itemprop="datePublished">2021-12-22</time>
</a>
    
  </div>
  <div class="article-inner">
    
    
      <header class="article-header">
        
  
    <h1 class="p-name article-title" itemprop="headline name">
      Higher Order Function Chaining in JavaScript
    </h1>
  

      </header>
    
    <div class="e-content article-entry" itemprop="articleBody">
      
        <p>Let us assume, we have higher order functions in our code which are performing different operations according to their usage. We have a situation like this, “Calculate the sum of odd numbers in given array”.</p>
<p>We have to get the odd numbers first</p>
<figure class="highlight plaintext"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br></pre></td><td class="code"><pre><span class="line">let array = [1,2,3,4,5,6,7,8,9];</span><br><span class="line"></span><br><span class="line">let oddNumbers = array.filter((number) =&gt; &#123;</span><br><span class="line">    return number%2 == 1</span><br><span class="line">&#125;);</span><br></pre></td></tr></table></figure>

<p>After finding odd number we have calculate the sum of those numbers</p>
<figure class="highlight plaintext"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line">sumOfOddNumbers = oddNumbers.reduce((a,b) =&gt; &#123;</span><br><span class="line">    return a+b</span><br><span class="line">&#125;)</span><br></pre></td></tr></table></figure>

<p>We have used two variables to store two results and extra lines of codes for doing calculation. But we can do this more easier to write and more readable by using higher order function chaining.</p>
<h2 id="Higher-Order-Function-Chaining"><a href="#Higher-Order-Function-Chaining" class="headerlink" title="Higher Order Function Chaining"></a>Higher Order Function Chaining</h2><p>It means we can chain the higher oreder function one with one to get the job done with less code of lines and it will be easier to read.</p>
<p>In this example we try to solve the above calculation using higher order function chaining</p>
<figure class="highlight plaintext"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br></pre></td><td class="code"><pre><span class="line">let array = [1,2,3,4,5,6,7,8,9];</span><br><span class="line"></span><br><span class="line">let sumOfOddNumbers = array.filter((number) =&gt; &#123;</span><br><span class="line">    return number % 2 == 1;</span><br><span class="line">&#125;)</span><br><span class="line">.reduce((a,b) =&gt; &#123;</span><br><span class="line">    return a+b;</span><br><span class="line">&#125;);</span><br></pre></td></tr></table></figure>

<p>In this way we can chain multiple higher order functions. But there are some key points to remember while chaining higher order functions:</p>
<ul>
<li>Every higher order function should return a value.</li>
<li>The value returned by a higher order function can be usable by other function which is we are chaining to it.</li>
</ul>

      
    </div>
    <footer class="article-footer">
      <a data-url="http://example.com/2021/12/22/chaining/" data-id="ckxh5nb4p00009n6q2253112f" data-title="Higher Order Function Chaining in JavaScript" class="article-share-link">Share</a>
      
      
      
    </footer>
  </div>
  
    
<nav id="article-nav">
  
  
    <a href="/2021/12/22/sort-method/" id="article-nav-older" class="article-nav-link-wrap">
      <strong class="article-nav-caption">Older</strong>
      <div class="article-nav-title">JavaScript Sort</div>
    </a>
  
</nav>

  
</article>


</section>
        
          <aside id="sidebar">
  
    

  
    

  
    
  
    
  <div class="widget-wrap">
    <h3 class="widget-title">Archives</h3>
    <div class="widget">
      <ul class="archive-list"><li class="archive-list-item"><a class="archive-list-link" href="/archives/2021/12/">December 2021</a></li></ul>
    </div>
  </div>


  
    
  <div class="widget-wrap">
    <h3 class="widget-title">Recent Posts</h3>
    <div class="widget">
      <ul>
        
          <li>
            <a href="/2021/12/22/chaining/">Higher Order Function Chaining in JavaScript</a>
          </li>
        
          <li>
            <a href="/2021/12/22/sort-method/">JavaScript Sort</a>
          </li>
        
      </ul>
    </div>
  </div>

  
</aside>
        
      </div>
      <footer id="footer">
  
  <div class="outer">
    <div id="footer-info" class="inner">
      
      &copy; 2021 John Doe<br>
      Powered by <a href="https://hexo.io/" target="_blank">Hexo</a>
    </div>
  </div>
</footer>

    </div>
    <nav id="mobile-nav">
  
    <a href="/" class="mobile-nav-link">Home</a>
  
    <a href="/archives" class="mobile-nav-link">Archives</a>
  
</nav>
    


<script src="/js/jquery-3.4.1.min.js"></script>



  
<script src="/fancybox/jquery.fancybox.min.js"></script>




<script src="/js/script.js"></script>





  </div>
</body>
</html>